
-- Frabel ls modding (Lesagri)
-- @date  12/06/2016

Leboulch = {};

function Leboulch.prerequisitesPresent(specializations)
	  return SpecializationUtil.hasSpecialization(Fillable, specializations) and SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function Leboulch:load(xmlFile)

	self.animPortes = false;   
	
	self.playerinrange = false;	
		
	self.portesNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.portes#index"));
	
	self.isSelectable = true;

end;

function Leboulch:delete()

end;

function Leboulch:readStream(streamId, connection)
self.animPortes = streamReadBool(streamId);	
end;

function Leboulch:writeStream(streamId, connection)
streamWriteBool(streamId, self.animPortes);
 
end;

function Leboulch:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Leboulch:keyEvent(unicode, sym, modifier, isDown) 
end;

function Leboulch:update(dt)
	
	    
	
	if self.sendanimPortes ~= self.animPortes then
    self.sendanimPortes = self.animPortes;
    animPortesEvent:sendEvent(self, self.animPortes);
end;  
	if self.playerinrange then
		if InputBinding.hasEvent(InputBinding.PORTES) and self.fillLevel <= 0 and self.animationParts[1].currentPosition <= 0  then
			self.animPortes = not self.animPortes			
		end;

		if self.animPortes then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Fermer"), self.typeDesc), InputBinding.PORTES);
		else if self.fillLevel <= 0 and self.animationParts[1].currentPosition <= 0 then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Ouvrir"), self.typeDesc), InputBinding.PORTES);
			end;
		end;
	end;	
	if self:getIsActiveForInput() and self:getIsActive() then
		local isKeyEvent = false;
		if self.tipState == Trailer.TIPSTATE_CLOSED and self.varBody.activeIdx ~= 1 and self.animationParts[1].currentPosition <= 0 then
			if InputBinding.isPressed(InputBinding.LEVER_BENNE) and self:getIsActiveForInput() then
				self:setAnimationTime(3, self.animationParts[3].currentPosition+(self.animationParts[3].offSet*(dt/10)));
				isKeyEvent = true;
			elseif InputBinding.isPressed(InputBinding.DESCENDRE_BENNE) and self:getIsActiveForInput() then
				self:setAnimationTime(3, self.animationParts[3].currentPosition-(self.animationParts[3].offSet*(dt/10)));
				isKeyEvent = true;
			end;
		end;
	end;
	if self:getIsActive() then
		for _, part in pairs(self.movingParts) do
			Cylindered.setDirty(self, part);
		end;
	end;
end;

function Leboulch:updateTick(dt)

if self.isClient then               
  if self.animPortes then               
			   self:setAnimationTime(2, self.animationParts[2].animDuration)
          else       			
				self:setAnimationTime(2, self.animationParts[2].startPosition);       
	end;
end;   
  	if self.attacherVehicle and g_currentMission.player ~= nil then
		local nearestDistance = 2.0;
		local px, py, pz = getWorldTranslation(self.portesNode);
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		if distance < nearestDistance then
			self.playerinrange = true;
		else
			self.playerinrange = false;
		end;
	end;	
end;

function Leboulch:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
    return BaseMission.VEHICLE_LOAD_OK;
end;

function Leboulch:getSaveAttributesAndNodes(nodeIdent)
end;
  
function Leboulch:onDetach()
end;

function Leboulch:onAttach()
end;

function Leboulch:draw() 
	if g_currentMission.showHelpText and self.isClient then
      g_currentMission:addExtraPrintText(g_i18n:getText("PORTE"));
	end;
    if self.tipState == Trailer.TIPSTATE_CLOSED and self.varBody.activeIdx ~= 1 and self.animationParts[1].currentPosition <= 0 then 
	    if self.animationParts[3].clip then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("DESCENDRE_BENNE")), InputBinding.DESCENDRE_BENNE);
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("LEVER_BENNE")), InputBinding.LEVER_BENNE);
	    end;
	end;
end;

--Animation porte Event--

animPortesEvent = {};
animPortesEvent_mt = Class(animPortesEvent, Event);

InitEventClass(animPortesEvent, "animPortesEvent");

function animPortesEvent:emptyNew()
  local self = Event:new(animPortesEvent_mt);
  self.className="animPortesEvent";
  return self;
end;

function animPortesEvent:new(object, animPortes)
  local self = animPortesEvent:emptyNew();
  self.object = object;
  self.animPortes = animPortes;
  return self;
end;

function animPortesEvent:readStream(streamId, connection)
  self.object = networkGetObject(streamReadInt32(streamId));
  self.animPortes = streamReadBool(streamId);
  self:run(connection);
end;

function animPortesEvent:writeStream(streamId, connection)
  streamWriteInt32(streamId, networkGetObjectId(self.object));
  streamWriteBool(streamId, self.animPortes);
end;

function animPortesEvent:run(connection)
  self.object.animPortes = self.animPortes;  
  if not connection:getIsServer() then
    g_server:broadcastEvent(animPortesEvent:new(self.object, self.animPortes), nil, connection, self.object);
  end;
end;

function animPortesEvent:sendEvent(object, animPortes, noEventSend)
  if noEventSend == nil or noEventSend == false then
    if g_server ~= nil then
      g_server:broadcastEvent(animPortesEvent:new(object, animPortes), nil, nil, object);
    else
      g_client:getServerConnection():sendEvent(animPortesEvent:new(object, animPortes));
    end;
  end;
end;